---
title: Keep-Alive
slug: Web/HTTP/Headers/Keep-Alive
tags:
  - General Header
  - HTTP
  - HTTP Header
  - Reference
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>Keep-Alive</code></strong> general header allows the sender to hint about how the connection may be used to set a timeout and a maximum amount of requests.</p>

<div class="note">
<p>The {{HTTPHeader("Connection")}} header needs to be set to "keep-alive" for this header to have any meaning.</p>
</div>

<div class="notecard warning">
<p>Connection-specific header fields such as {{HTTPHeader("Connection")}} and {{HTTPHeader("Keep-Alive")}} are <a href="https://tools.ietf.org/html/rfc7540#section-8.1.2.2">prohibited in HTTP/2</a>. Chrome and Firefox ignore them in HTTP/2 responses, but Safari conforms to the HTTP/2 spec requirements and won’t load any response which contains them.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("General header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>yes</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Keep-Alive: <var>parameters</var></pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt><code><var>parameters</var></code></dt>
 <dd>A comma-separated list of parameters, each consisting of an identifier and a value separated by the equal sign (<code>'='</code>). The following identifiers are possible:
 <ul>
  <li><code>timeout</code>: indicating the <em>minimum </em>amount of time an idle connection has to be kept opened (in seconds). Note that timeouts longer than the TCP timeout may be ignored if no keep-alive TCP message is set at the transport level.</li>
  <li><code>max</code>: indicating the maximum number of requests that can be sent on this connection before closing it. Unless <code>0</code>, this value is ignored for non-pipelined connections as another request will be sent in the next response. An HTTP pipeline can use it to limit the pipelining.</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>A response containing a <code>Keep-Alive</code> header:</p>

<pre class="notranslate">HTTP/1.1 200 OK
<strong>Connection: Keep-Alive</strong>
Content-Encoding: gzip
Content-Type: text/html; charset=utf-8
Date: Thu, 11 Aug 2016 15:23:13 GMT
<strong>Keep-Alive: timeout=5, max=1000</strong>
Last-Modified: Mon, 25 Jul 2016 04:32:39 GMT
Server: Apache

(body)</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="https://tools.ietf.org/html/draft-thomson-hybi-http-timeout-03#section-2">HTTP Keep-Alive Header</a></td>
   <td>Keep-Alive Header (IETF Internet Draft)</td>
  </tr>
  <tr>
   <td><a href="https://tools.ietf.org/html/rfc7230#appendix-A.1.2">RFC 7230, appendix A.1.2: Keep-Alive</a></td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Keep-Alive")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Connection")}}</li>
 <li><a href="/en-US/docs/Web/HTTP/Connection_management_in_HTTP_1.x">Connection management in HTTP/1.x</a></li>
</ul>
